<template lang="pug">
BaseCard(key="opYearPeriodDueShiftPoints" tabIndex="-1").highlightOnFocus
  template(v-slot:header='')
    BaseAnimationBlock
      .d-flex(key='title')
        h5 Due Points for #[span.text-muted {{ year }}]
        template(v-if="editable")
          span.ml-4.text-danger(v-if="valuesOutdated")
            i.fa.fa-exclamation-circle
            span.ml-2 Data needs recomputation.
          .ml-auto.d-flex.justify-content-between
            .clickable.mx-1(@click='showInfoModal()')
              i.fas.fa-info-circle
            .clickable.mx-1(@click='setEdit(true)' v-if='!inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") E
              i.fa.fa-cog
            .clickable.mx-1(@click='setEdit(false)' v-if='inEdit')
              kbd.keyHint.mr-2(v-if="showKeyHints") Esc
              i.fa.fa-times
          ShiftDuePointsFormulaDialog(ref='infoDialog')
        template(v-else)
          .ml-auto.d-flex.justify-content-between
            span #[strong Points Per User]: {{ duePointsPerUser }}
  li.p-0(key='shiftDuePointsCalendar').x-shift-due-points
    BaseModalLoader(:isLoading="loading")
    table.table.table-sm.table-hover.text-center
      thead.bg-light.table-head
        tr
          th Status
          th.text-left Institute
          th # Users
          th Due Shift Points
          th(v-if="inEdit") Former Value
      tbody
        // TOTAL Row
        tr
          td
          td.text-right #[strong TOTAL]
          td
            strong(v-if="inEdit") {{ totNUsersInEdit }}
            strong(v-else) {{ sumUsers }}
          td
            strong(v-if="inEdit") {{ totDueShiftsInEdit }}
            strong(v-else) {{ sumPoints }}
          td(v-if="inEdit")
            small.text-muted ({{ sumPoints }})

        // Institutes
        tr(v-for="inst in sortedInstitutes" v-if="editable || (!editable && inst.status === 1)")
          td.text-center
            .fa.fa-check(v-if='inst.status')
            .fa.fa-times(v-else)
          td.text-left
              InstituteLink(:id="inst.id" :institute="inst" tabIndex=-1)
                tt.m-0.p-0 {{ `${inst.alias} (${inst.city}, ${inst.country})` }}
          // Institute with DuePoints
          template(v-if='dp' v-for='dp in [ getInstituteDuePoints(inst.id) ]')
            td
              BaseInput(v-if="editable" :ref="`inst-${inst.id}-nu`" v-model="dp.nUsers" :inEdit="inEdit" :noEditIcon="true"
                type="number" step="1" min="0" required @edit="onEditNUsers($event, dp)")
              span(v-else) {{ dp.nUsers }}
            td.x-sp-readonly
              BaseInput(v-if="editable" :ref="`inst-${inst.id}-sp`" v-model="dp.shiftPoints" :inEdit="inEdit" :noEditIcon="true"
                type="number" tabIndex=-1 readonly)
              span(v-else) {{ dp.shiftPoints }}
            td(v-if="inEdit").align-middle
              small.text-muted ({{ dp.shiftPoints }})
          // Institute without DuePoints. Show create button
          template(v-else)
            td(colspan="4").text-muted.text-center
              span.mr-2 This institute has no due points.
              button.btn.btn-outline-primary.btn-sm(v-if="!inEdit && editable"
                @click='createDuePointsRow(inst.id)' title='Create Due Points')
                i.fa.fa-pen.mr-1
                | Create

  li(v-if='processing' key='processing')
    .row.justify-content-center
      i.align-bottom.fa.fa-spinner.fa-pulse
  li(v-if='!loading && inEdit && !processing' key='submit')
    .d-flex.justify-content-between
      .mx-1
        button.btn.btn-primary.x-copy-prev(@click="copyPreviousYear()")
          i.fa.fa-copy.mr-1
          | Copy Previous Year
      .mx-1.d-flex.justify-content-end
        .alert.alert-warning.m-0.p-1(v-if="dirtyValue")
          i.fa.fa-exclamation-triangle.mx-2.p-0
          | Remember to save!
        button.btn.btn-primary.mx-1.x-submit(@click="doSubmit()")
          kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
          i.fa.fa-upload.mr-1(v-else)
          | Submit
</template>
<script>

export { default } from './ShiftDuePoints.vue.js';

</script>

<style>
.x-shift-due-points .table th {
  vertical-align: middle;
  font-size: 0.9rem;
}

.x-shift-due-points input {
  text-align: center;
}

.x-sp-readonly input {
  border: none !important;
}

.x-sp-readonly input:focus {
  border: none !important;
  box-shadow: none !important;
}
</style>
